angular.module('asset', [])
.factory('AssetService', ['$http', 'Configuration', function($http, Configuration){

    var getAssetDetails = function(assetType, assetId) {
        return $http.get(Configuration.api_prefix + "/" + assetType + '/' + assetId);
    }

    var getAssetVersions = function(assetType, assetId) {
        return $http.get(Configuration.api_prefix + "/" + assetType + '/' + assetId + '/versions')
    }

    var getAssetVersionDiffs = function(assetType, assetId) {
        return $http.get(Configuration.api_prefix + "/" + assetType + '/' + assetId + '/versions?diff')
    }

    return {
        get: getAssetDetails,
        getVersions: getAssetVersions,
        getDiffs: getAssetVersionDiffs
    }

}])
.controller('assetController', ['$scope', '$routeParams', 'AssetService', 
    function($scope, $routeParams, AssetService) {

        $scope.asset = {};

        AssetService.get($routeParams.asset_type, $routeParams.asset)
        .success(function(rslt) {
            $scope.asset = rslt;
        }).error(function(err) {
            console.log(err);
        })

    }
])
.controller('assetVersionsController', ['$scope', '$routeParams', 'AssetService', 
    function($scope, $routeParams, AssetService) {

        $scope.versions = [];
        $scope.asset = {
            type: $routeParams.asset_type,
            id: $routeParams.asset
        };

        AssetService.getDiffs($routeParams.asset_type, $routeParams.asset)
        .success(function(rslt) {
            $scope.versions = rslt;
            console.log($scope.versions);
        }).error(function(err) {
            console.log(err);
        });
    }
]);