angular.module('login', [])
.factory('CredCache', ['$window', function($window) {

    var getCreds = function() {
        if ($window.sessionStorage['infra-inventory']) {
            try {
                return JSON.parse($window.sessionStorage['infra-inventory']);
            } catch(e) {
                console.error(e);
                return {};
            }
        } else {
            return {};
        }
    }

    var setCreds = function(user, pass) {
        var creds = getCreds();
        creds.username = user;
        creds.password = pass;
        $window.sessionStorage['infra-inventory'] = JSON.stringify(creds);
    }

    return {
        getCreds: getCreds,
        setCreds: setCreds
    }
}])
.factory('Authenticator', [
    '$window', '$http', '$location', 'CredCache',
    function($window, $http, $location, CredCache) {
    
        function _sessionIsAuthenticated() {
            //if($window.sessionStorage['credentials']) {

            //    var creds = JSON.parse($window.sessionStorage['credentials']);
            //    if(creds.username && creds.username !== "" && creds.password && creds.password !== "") {
                    // do custom checking here
            //        return true
            //    }
            //}
            //return false;
        }

        // do actual auth here //
        function _login(creds) {
            if(creds.password === "guest") {
                $window.sessionStorage['credentials'] = JSON.stringify(creds);
                return true;
            }
            return false;
        }
        
        function _logout() {
            var sStor = $window.sessionStorage;
            if(sStor['credentials']) {
                delete sStor['credentials'];
            }
            $location.url("/login");
        }

        function _checkAuthOrRedirect(redirectTo) {
            if(!_sessionIsAuthenticated()){
                if(redirectTo) $location.url("/login?redirect="+redirectTo);   
                else $location.url("/login");
            }
        }
        
        return {
            login                 : _login,
            logout                : _logout,
            sessionIsAuthenticated: _sessionIsAuthenticated,
            checkAuthOrRedirect   : _checkAuthOrRedirect
        };

    }
])
.controller('loginController', [
    '$scope', '$window', '$routeParams', '$location', 'Authenticator', 'Configuration', 'CredCache',
    function($scope, $window, $routeParams, $location, Authenticator, Configuration, CredCache) {
        
        var defaultPage = "/";
        $scope.credentials = CredCache.getCreds();

        $scope.attemptLogin = function() {
        }
    }
]);